﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class ShowPolicies : System.Web.UI.Page
{
    /* we will be using the LINQ to SQL generated data context */
    DataClassesDataContext insuranceDB = new DataClassesDataContext();

    protected void Page_Load(object sender, EventArgs e)
    {
        /* No error message to display */
        DatabaseError.Enabled = false;


    }

    protected void PoliciesView_SelectedIndexChanged(object sender, EventArgs e)
    {
        if (PoliciesView.SelectedRow == null)
            /* Don't dislay any edit/new claim dialog */
            ChangeClaimView.ActiveViewIndex = -1;
        else
        /* a policy has been selected by the user */
        {
            ChangeClaimView.ActiveViewIndex = 1;
            /* get the policy ID of the selected policy */
            int polID = (int)PoliciesView.SelectedValue;
            var polType = (from policy in insuranceDB.policies
                           where policy.policyID == polID
                           select policy.type).Single();

            DateTime today = System.DateTime.Today;

            string newRef = polType.Substring(0, 1).ToUpper() + today.Year.ToString()
                + "-" + polID.ToString("00") + "-"
                + System.DateTime.Now.Millisecond.ToString("000");

            /* initialise claim date and reference */
            reference.Text = newRef;
            claimDate.Text = today.ToShortDateString();
        }
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        /* Only go ahead if validation has succeeded */
        if (Page.IsValid)
        {
            claim newClaim = new claim();
            newClaim.claimDate = System.DateTime.Parse(claimDate.Text);
            newClaim.reference = reference.Text;
            newClaim.description = description.Text;
            newClaim.amount = Convert.ToDecimal(amount.Text);
            newClaim.policyID = (int) PoliciesView.SelectedValue;
            newClaim.approved = 'N';

            try
            {
                DatabaseError.Text = "";
                insuranceDB.claims.InsertOnSubmit(newClaim);
                insuranceDB.SubmitChanges();
                /* refresh view of claims, and remove new claim dialog */
                ClaimsView.DataBind();
                ChangeClaimView.ActiveViewIndex = -1;
            }
            catch (Exception myEx)
            {
                DatabaseError.Enabled = true;
                DatabaseError.Text = "Database insertion failed.";
            }
        }
    }
    
    protected void ClaimsView_SelectedIndexChanged(object sender, EventArgs e)
    {
        if(ClaimsView.SelectedRow == null)
            ChangeClaimView.ActiveViewIndex = -1;
        else
            /* show edit claim dialog */
            ChangeClaimView.ActiveViewIndex = 0;
    }

    protected void FormView1_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
    {
        if (e.Exception != null || e.AffectedRows != 1)
        {
            DatabaseError.Enabled = true;
            DatabaseError.Text = "Database update failed.";
        }
        ClaimsView.DataBind();
    }

}
